## FormFonts Exporter - Alpha version
##

require 'sketchup.rb'
require 'fileutils.rb'

#exporter methods

def xpt_dwg()
  dwgpath = $outdir + $modelname + ".dwg"
  $model.export(dwgpath, false)
end

def xpt_jpg(postp)
  
  if postp=="true" then
    jpgpath = $outdir + $modelname + "_thumb.jpg"
    myview = $model.active_view
    myview.invalidate
    thumb = myview.write_image(jpgpath, 400, 400, true, 7)
  else
    if postp=="IM" then
      Dir.chdir($outdir)
      pngpath = $modelname + "_thumb.png"
      jpgpath = $modelname + "_thumb.jpg"
      myview = $model.active_view
      myview.invalidate
      thumb = myview.write_image(pngpath, 1600, 1200, true, 9)
        if RUBY_PLATFORM =~ /darwin/ then
          imcmd = "/opt/local/bin/convert " + pngpath + " -shave 200x0 -filter blackman -resize 400x400 -quality 100 " + jpgpath
        else
          imcmd = "\"C:\\Program Files\\ImageMagick-6.4.9-Q16\\convert.exe\" " + pngpath + " -shave 200x0 -filter blackman -resize 400x400 -quality 100 " + jpgpath
      end
      system(imcmd)
    else
      if postp == "IM DC" then
        Dir.chdir($outdir)
        pngpath = $modelname + "_thumb.png"
        jpgpath = $modelname + "_thumb.jpg"
        myview = $model.active_view
        myview.invalidate
        thumb = myview.write_image(pngpath, 1600, 1200, true, 9)
        if RUBY_PLATFORM =~ /darwin/ then
          imcmd = "/opt/local/bin/convert " + pngpath + " -shave 200x0 -filter blackman -resize 400x400 -quality 100  -gravity southwest \"" + $plugindir + "/dc_overlay.png\" -compose Over -composite " + jpgpath
        else
          imcmd = "\"C:\\Program Files\\ImageMagick-6.4.9-Q16\\convert.exe\" " + pngpath + " -shave 200x0 -filter blackman -resize 400x400 -quality 100  -gravity southwest \"" + $plugindir + "\\dc_overlay.png\" -compose Over -composite " + jpgpath
        end
        system(imcmd)
      end
    end
  end
end

def xpt_3ds()
  tdstmp = $outdir + "3dstmp/"
  Dir.mkdir tdstmp
  tdspath = tdstmp + $modelname + ".3ds"
  $model.export(tdspath, true)
  list = Dir.entries(tdstmp + "*")
  list.delete_if{|l| l =~ /3dstmp\/.*\.3ds/}
  if list.size>0 then
    Dir.chdir(tdstmp)
    zipcmd = "zip -rqm " + $modelname + ".3ds.zip *"
    system(zipcmd)
    FileUtils.mv($modelname + ".3ds.zip",$outdir)
 else
    FileUtils.mv(tdspath,$outdir)
  end
end

def xpt_fbx()
  fbxtmp = $outdir + "fbxtmp/"
  Dir.mkdir fbxtmp
  fbxpath = fbxtmp + $modelname + ".fbx"
  $model.export(fbxpath, true)
  list = Dir.glob(fbxtmp + "*")
  list.delete_if{|l| l =~ /fbxtmp\/.*\.fbx/}
  if list.size>0 then
    Dir.chdir(fbxtmp)
    zipcmd = "zip -rqm " + $modelname + ".fbx.zip *"
    system(zipcmd)
    FileUtils.mv($modelname + ".fbx.zip",$outdir)
 else
    FileUtils.mv(fbxpath,$outdir)
  end
end

def xpt_dae()
  daetmp = $outdir + "daetmp/"
  Dir.mkdir daetmp
  daepath = daetmp + $modelname + ".dae"
  $model.export(daepath, true)
  list = Dir.glob(daetmp + "*")
  list.delete_if{|l| l =~ /daetmp\/.*\.dae/}
  if list.size>0 then
    Dir.chdir(daetmp)
    zipcmd = "zip -rqm " + $modelname + ".dae.zip *"
    system(zipcmd)
    FileUtils.mv($modelname + ".dae.zip",$outdir)
  else
    FileUtils.mv(daepath,$outdir)
  end
end

def xpt_obj()
  objtmp = $outdir + "objtmp/"
  Dir.mkdir objtmp
  objpath = objtmp +$modelname + ".obj"
  $model.export(objpath, true)
  Dir.chdir(objtmp)
  zipcmd = "zip -rqm " + $modelname + ".obj.zip *"
  system(zipcmd)
  FileUtils.mv($modelname + ".obj.zip",$outdir)
end


def xpt_skp_cms()
  Dir.chdir($outdir)
  cmspath = $modelname + ".skp"
  status = $model.save cmspath
end  

##core
def ffexport()

  # set up initial variables

  $model = Sketchup.active_model
  $modeldir = $model.path.chomp($model.title + ".skp")
  $modelname = $model.title.gsub(/[^a-zA-Z0-9_]*/, "")
  $outdir = $modeldir + $modelname + "_out/"
  $plugindir = File.dirname(__FILE__)
  conffile = $plugindir + "/ffexport.conf"

  # get the formats to export

  formats = ["dwg","3ds","dae","obj","fbx","jpg"]
  defaultvals = ["false","false","false","false","false","true"]
  possanswers = ["true|false","true|false","true|false","true|false","true|false","true|false|IM|IM DC"]
  if (FileTest.exist?(conffile))
    string = IO.read(conffile)
    vals_stor = string.split("\n")
    if (defaultvals.length == vals_stor.length)
      vals = vals_stor
    else
      vals = defaultvals
    end
  else
    vals = defaultvals
  end

  results = inputbox formats, vals, possanswers, "Which formats to export?"

  #start the real work
  if(results)

    #change to cms to standardise units
    if RUBY_PLATFORM =~ /darwin/ then
      $model.options[2][1] = 0 
      $model.options[2][2] = 3 
    else
      $model.options[0][1] = 0 
      $model.options[0][2] = 3 
    end

    
    if (not (FileTest.exist?($outdir)))
      Dir.mkdir $outdir
    end

    xpt_dwg() if results[0]=="true"
    
    xpt_3ds() if results[1]=="true"
    
    xpt_dae() if results[2]=="true"

    xpt_obj() if results[3]=="true"

    xpt_fbx() if results[4]=="true"

    xpt_jpg(results[4]) if results[5]!="false"

    xpt_skp_cms()


    #write out which formats were output last
    File.open(conffile,"w"){|f| f.puts results}

    #cleanup here, in case something is stupid and locks the dirs
    tdstmp = $outdir + "3dstmp/"
    daetmp = $outdir + "daetmp/"
    objtmp = $outdir + "objtmp/"
    fbxtmp = $outdir + "fbxtmp/"
    Dir.chdir($outdir)
    FileUtils.rm_rf(tdstmp) if (FileTest.exist?(tdstmp))
    FileUtils.rm_rf(daetmp) if (FileTest.exist?(daetmp))
    FileUtils.rm_rf(objtmp) if (FileTest.exist?(objtmp))
    FileUtils.rm_rf(fbxtmp) if (FileTest.exist?(fbxtmp))


  end
end

if(not $ffexport_menu_loaded)
  add_separator_to_menu("Plugins")
  UI.menu("Plugins").add_item("FF Exporter") {ffexport}
end

$ffexport_menu_loaded = true
